Imports SubSystems.RC
Imports SubSystems.PDG
Imports System.IO


Public Class Form1
    Inherits System.Windows.Forms.Form

    '''''''''''''''''''''''''''''''''''''''''''''''''/
    '/    constants
    '''''''''''''''''''''''''''''''''''''''''''''''''/
    Const ID_NEW = 0                   ' new docuemnt
    Const ID_INIT_SECT = 1             ' initialize section
    Const ID_BEGIN_TEXT = 2            ' begin text
    Const ID_RESET_CHAR_PROP = 3       ' reset the character properties
    Const ID_SET_FONT = 4              ' set font/color
    Const ID_CHAR_STYLE_ID = 5         ' specify the character style id
    Const ID_RESET_PARA_PROP = 6       ' reset the paragraph properties
    Const ID_PARA_CENTER = 7           ' centered paragraph
    Const ID_PARA_RIGHT = 8            ' right justified paragraph
    Const ID_PARA_DOUBLE_SPACE = 9     ' double space paragraph
    Const ID_PARA_BORDER = 10          ' paragraph border
    Const ID_PARA_INDENT = 11          ' paragraph indentation
    Const ID_PARA_SPACE = 12           ' paragraph spacing
    Const ID_PARA_SHADE = 13           ' paragraph shading
    Const ID_PARA_BULLET = 14          ' paragraph bullet
    Const ID_PARA_NUMBERING = 15       ' paragraph numbering
    Const ID_PARA_TAB_STOP = 16        ' paragraph tab stops
    Const ID_PARA_STYLE_ID = 17        ' specify the paragraph style id
    Const ID_INSERT_TEXT = 18          ' append text
    Const ID_INSERT_TABLE = 19         ' insert a table
    Const ID_INSERT_PICT = 20          ' insert a picture file as linked
    Const ID_INSERT_LINK_PICT = 21     ' insert a picture file as linked
    Const ID_PASTE_PICT = 22           ' paste from clipboard or memory
    Const ID_PAPER = 23                ' set paper size
    Const ID_MARGIN = 24               ' set margin
    Const ID_SECT_INFO = 25            ' section information
    Const ID_BEGIN_HDR = 26            ' begin the header group
    Const ID_END_HDR = 27              ' end the header group
    Const ID_BEGIN_FTR = 28            ' begin the footer group
    Const ID_END_FTR = 29              ' end the footer group
    Const ID_BEGIN_STYLESHEET = 30     ' begin stylesheet
    Const ID_BEGIN_STYLEITEM = 31      ' begin a style item
    Const ID_END_STYLEITEM = 32        ' end styleitem
    Const ID_END_STYLESHEET = 33       ' end stylesheet
    Const ID_BEGIN_FRAME = 34          ' begin a frame
    Const ID_END_FRAME = 35            ' end the current frame
    Const ID_BEGIN_TEXT_BOX = 36       ' begin a text box
    Const ID_END_TEXT_BOX = 37         ' end the current text box
    Const ID_DRAW_RECT = 38            ' draw a rectangle
    Const ID_DRAW_LINE = 39            ' draw a line
    Const ID_PAGE_BREAK = 40           ' insert a page break
    Const ID_SECT_BREAK = 41           ' insert a section break
    Const ID_INSERT_PAGE_NO = 42       ' insert a page number and total pages
    Const ID_INSERT_MERGE_FIELD = 43   ' insert merge field
    Const ID_INSERT_RAW = 44           ' insert raw rtf code
    Const ID_INSERT_FNOTE = 45         ' insert footenote
    Const ID_OTHER = 46                ' testing code

    '''''''''''''''''''''''''''''''''''''''''''''''''/
    '/    Internal variables
    '''''''''''''''''''''''''''''''''''''''''''''''''/
    Dim pdg As Pdg                         ' Report object
    Dim doc As Rcn                         ' document object
    Dim CurFct As Integer                  ' current function id
    Dim StyleItemCount As Integer          ' number of styles in the stylesheet
    Dim InputBoxHeight As Integer          ' height of the input box


#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        pdg = New Pdg                ' create a new report object
        doc = pdg.PdgNewDocObject()  ' new document object for the report

        CurFct = 0
        StyleItemCount = 0
        InputBoxHeight = 0

        ' fill in the list box
        SetFunctionName(ID_NEW, "New Document")
        SetFunctionName(ID_INIT_SECT, "Initialize Section")
        SetFunctionName(ID_BEGIN_TEXT, "Begin Section Text")
        SetFunctionName(ID_RESET_CHAR_PROP, "Reset Character Properties")
        SetFunctionName(ID_SET_FONT, "Set Font...")
        SetFunctionName(ID_CHAR_STYLE_ID, "Set Character Style Id")
        SetFunctionName(ID_RESET_PARA_PROP, "Reset Paragraph Properties")
        SetFunctionName(ID_PARA_CENTER, "Paragraph Centering")
        SetFunctionName(ID_PARA_RIGHT, "Paragraph Right Justification")
        SetFunctionName(ID_PARA_DOUBLE_SPACE, "Paragraph Double Spacing")
        SetFunctionName(ID_PARA_BORDER, "Paragraph Border")
        SetFunctionName(ID_PARA_INDENT, "Paragraph Indents")
        SetFunctionName(ID_PARA_SPACE, "Paragraph Spacing")
        SetFunctionName(ID_PARA_SHADE, "Paragraph Shading")
        SetFunctionName(ID_PARA_BULLET, "Paragraph Bullet")
        SetFunctionName(ID_PARA_NUMBERING, "Paragraph Numbering")
        SetFunctionName(ID_PARA_TAB_STOP, "Paragraph Tab Stops")
        SetFunctionName(ID_PARA_STYLE_ID, "Set Paragraph Style Id")
        SetFunctionName(ID_INSERT_TEXT, "Insert Text...")
        SetFunctionName(ID_INSERT_TABLE, "Insert Table")
        SetFunctionName(ID_INSERT_PICT, "Insert a Picture file...")
        SetFunctionName(ID_INSERT_LINK_PICT, "Insert a Linked Picture file...")
        'SetFunctionName(ID_PASTE_PICT,"Paste Picture") 
        SetFunctionName(ID_PAPER, "Set Paper Size")
        SetFunctionName(ID_MARGIN, "Set Page Margin")
        SetFunctionName(ID_SECT_INFO, "Set Section Information")
        SetFunctionName(ID_BEGIN_HDR, "Begin Header Group")
        SetFunctionName(ID_END_HDR, "End Header Group")
        SetFunctionName(ID_BEGIN_FTR, "Begin Footer Group")
        SetFunctionName(ID_END_FTR, "End Footer Group")
        SetFunctionName(ID_BEGIN_STYLESHEET, "Begin Stylesheet")
        SetFunctionName(ID_BEGIN_STYLEITEM, "Begin a Stylesheet Item")
        SetFunctionName(ID_END_STYLEITEM, "End a Stylesheet Item")
        SetFunctionName(ID_END_STYLESHEET, "End Stylesheet")
        SetFunctionName(ID_BEGIN_FRAME, "Begin Frame Group")
        SetFunctionName(ID_END_FRAME, "End Frame Group")
        SetFunctionName(ID_BEGIN_TEXT_BOX, "Begin a Text Box Group")
        SetFunctionName(ID_END_TEXT_BOX, "End Text Box Group")
        SetFunctionName(ID_DRAW_RECT, "Draw a Rectangle")
        SetFunctionName(ID_DRAW_LINE, "Draw a Line")
        SetFunctionName(ID_PAGE_BREAK, "Insert a page break")
        SetFunctionName(ID_SECT_BREAK, "Insert a section break")
        SetFunctionName(ID_INSERT_PAGE_NO, "Insert Page Number")
        SetFunctionName(ID_INSERT_MERGE_FIELD, "Insert a Mail/Merge Field")
        SetFunctionName(ID_INSERT_RAW, "Insert Raw RTF Code...")
        SetFunctionName(ID_INSERT_FNOTE, "Insert footnote...")
        SetFunctionName(ID_OTHER, " ")

        ' hide the input area
        Input1Title.Visible = False
        Input1Text.Visible = False
        OK.Visible = False

        AutoRefresh.Checked = True
        InputBoxHeight = Input1Text.Height

        ' start a new document
        CallFunction(ID_NEW, False)


    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Friend WithEvents Panel1 As System.Windows.Forms.Panel
    Friend WithEvents OK As System.Windows.Forms.Button
    Friend WithEvents Input1Title As System.Windows.Forms.Label
    Friend WithEvents Input1Text As System.Windows.Forms.TextBox
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Rtf As System.Windows.Forms.TextBox
    Friend WithEvents Label2 As System.Windows.Forms.Label
    Friend WithEvents AutoRefresh As System.Windows.Forms.CheckBox
    Friend WithEvents Box As System.Windows.Forms.ListBox
    Friend WithEvents FileBox As System.Windows.Forms.Panel
    Friend WithEvents Label3 As System.Windows.Forms.Label
    Friend WithEvents OutputFile As System.Windows.Forms.TextBox
    Friend WithEvents UseBuffer As System.Windows.Forms.CheckBox
    Friend WithEvents Status As System.Windows.Forms.Label
    Friend WithEvents GeneratePdf As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.Input1Title = New System.Windows.Forms.Label
        Me.Input1Text = New System.Windows.Forms.TextBox
        Me.Panel1 = New System.Windows.Forms.Panel
        Me.OK = New System.Windows.Forms.Button
        Me.Label1 = New System.Windows.Forms.Label
        Me.Rtf = New System.Windows.Forms.TextBox
        Me.Label2 = New System.Windows.Forms.Label
        Me.AutoRefresh = New System.Windows.Forms.CheckBox
        Me.Box = New System.Windows.Forms.ListBox
        Me.FileBox = New System.Windows.Forms.Panel
        Me.Status = New System.Windows.Forms.Label
        Me.UseBuffer = New System.Windows.Forms.CheckBox
        Me.OutputFile = New System.Windows.Forms.TextBox
        Me.Label3 = New System.Windows.Forms.Label
        Me.GeneratePdf = New System.Windows.Forms.Button
        Me.Panel1.SuspendLayout()
        Me.FileBox.SuspendLayout()
        Me.SuspendLayout()
        '
        'Input1Title
        '
        Me.Input1Title.Location = New System.Drawing.Point(8, 16)
        Me.Input1Title.Name = "Input1Title"
        Me.Input1Title.Size = New System.Drawing.Size(408, 16)
        Me.Input1Title.TabIndex = 0
        Me.Input1Title.Text = "Please enter the text here and click OK"
        '
        'Input1Text
        '
        Me.Input1Text.Location = New System.Drawing.Point(8, 32)
        Me.Input1Text.Multiline = True
        Me.Input1Text.Name = "Input1Text"
        Me.Input1Text.Size = New System.Drawing.Size(424, 64)
        Me.Input1Text.TabIndex = 1
        Me.Input1Text.Text = ""
        '
        'Panel1
        '
        Me.Panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.Panel1.Controls.Add(Me.Input1Title)
        Me.Panel1.Controls.Add(Me.Input1Text)
        Me.Panel1.Controls.Add(Me.OK)
        Me.Panel1.Location = New System.Drawing.Point(208, 400)
        Me.Panel1.Name = "Panel1"
        Me.Panel1.Size = New System.Drawing.Size(448, 144)
        Me.Panel1.TabIndex = 8
        '
        'OK
        '
        Me.OK.Location = New System.Drawing.Point(360, 112)
        Me.OK.Name = "OK"
        Me.OK.TabIndex = 9
        Me.OK.Text = "OK"
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(8, 8)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(136, 16)
        Me.Label1.TabIndex = 9
        Me.Label1.Text = "Select a Function Call"
        '
        'Rtf
        '
        Me.Rtf.Location = New System.Drawing.Point(208, 24)
        Me.Rtf.Multiline = True
        Me.Rtf.Name = "Rtf"
        Me.Rtf.Size = New System.Drawing.Size(448, 360)
        Me.Rtf.TabIndex = 11
        Me.Rtf.Text = ""
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(208, 8)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(144, 16)
        Me.Label2.TabIndex = 12
        Me.Label2.Text = "Intermediate RTF Code"
        '
        'AutoRefresh
        '
        Me.AutoRefresh.Location = New System.Drawing.Point(568, 8)
        Me.AutoRefresh.Name = "AutoRefresh"
        Me.AutoRefresh.Size = New System.Drawing.Size(96, 16)
        Me.AutoRefresh.TabIndex = 13
        Me.AutoRefresh.Text = "Auto Refresh"
        '
        'Box
        '
        Me.Box.Location = New System.Drawing.Point(8, 24)
        Me.Box.Name = "Box"
        Me.Box.Size = New System.Drawing.Size(184, 667)
        Me.Box.TabIndex = 14
        '
        'FileBox
        '
        Me.FileBox.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.FileBox.Controls.Add(Me.Status)
        Me.FileBox.Controls.Add(Me.UseBuffer)
        Me.FileBox.Controls.Add(Me.OutputFile)
        Me.FileBox.Controls.Add(Me.Label3)
        Me.FileBox.Location = New System.Drawing.Point(208, 552)
        Me.FileBox.Name = "FileBox"
        Me.FileBox.Size = New System.Drawing.Size(448, 96)
        Me.FileBox.TabIndex = 15
        '
        'Status
        '
        Me.Status.Location = New System.Drawing.Point(336, 72)
        Me.Status.Name = "Status"
        Me.Status.Size = New System.Drawing.Size(96, 16)
        Me.Status.TabIndex = 3
        '
        'UseBuffer
        '
        Me.UseBuffer.Location = New System.Drawing.Point(8, 64)
        Me.UseBuffer.Name = "UseBuffer"
        Me.UseBuffer.Size = New System.Drawing.Size(184, 16)
        Me.UseBuffer.TabIndex = 2
        Me.UseBuffer.Text = "Transfer file as buffer"
        '
        'OutputFile
        '
        Me.OutputFile.Location = New System.Drawing.Point(8, 24)
        Me.OutputFile.Name = "OutputFile"
        Me.OutputFile.Size = New System.Drawing.Size(424, 20)
        Me.OutputFile.TabIndex = 1
        Me.OutputFile.Text = "test.pdf"
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(8, 8)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(216, 16)
        Me.Label3.TabIndex = 0
        Me.Label3.Text = "Output File Name (*.pdf)"
        '
        'GeneratePdf
        '
        Me.GeneratePdf.Location = New System.Drawing.Point(456, 656)
        Me.GeneratePdf.Name = "GeneratePdf"
        Me.GeneratePdf.Size = New System.Drawing.Size(200, 32)
        Me.GeneratePdf.TabIndex = 16
        Me.GeneratePdf.Text = "Generate PDF"
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.ClientSize = New System.Drawing.Size(672, 709)
        Me.Controls.Add(Me.GeneratePdf)
        Me.Controls.Add(Me.FileBox)
        Me.Controls.Add(Me.Box)
        Me.Controls.Add(Me.AutoRefresh)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Rtf)
        Me.Controls.Add(Me.Label1)
        Me.Controls.Add(Me.Panel1)
        Me.Name = "Form1"
        Me.Text = "RTF Code Generator Demo"
        Me.Panel1.ResumeLayout(False)
        Me.FileBox.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub OK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OK.Click
        CallFunction(CurFct, True)  ' execute the current function
    End Sub
    Private Sub Box_SelectedIndexChanged1(ByVal sender As Object, ByVal e As System.EventArgs) Handles Box.SelectedIndexChanged
        Dim idx As Integer
        Dim item As ClsBox
        idx = Box.SelectedIndex
        If (idx >= 0) Then
            item = Box.SelectedItem
            CallFunction(item.value, False)       ' execute the selected method
        End If


    End Sub
    '******************************************************************************
    '    CallFunction:
    '    Call the specified API function.
    '******************************************************************************/
    Sub CallFunction(ByVal fct As Integer, ByVal OnOK As Boolean)

        Dim str As String
        Dim idx As Integer

        CurFct = fct                          ' current function

        Select Case (fct)
            Case ID_NEW                       ' new document
                doc = pdg.PdgNewDocObject()
                StyleItemCount = 0


            Case ID_BEGIN_STYLESHEET          ' begin the stylesheet group
                doc.RcgBeginStyleSheet()

            Case ID_BEGIN_STYLEITEM           ' begin a stylesheet item
                doc.RcgBeginStyleItem(True, StyleItemCount, "Normal")
                StyleItemCount = StyleItemCount + 1


            Case ID_END_STYLEITEM              ' end current stylesheet item
                doc.RcgEndStyleItem()

            Case ID_END_STYLESHEET             ' end current stylesheet group
                doc.RcgEndStyleSheet()


            Case ID_PAPER                     ' set paper size to 8.5 by 11 inches
                'RcgPaper((int)(8.5*1440),(int)(11*1440),false)   ' letter size portrait
                doc.RcgPaper(16834, 11909, True) ' A4 in landscape orientation


            Case ID_MARGIN                     ' set 1 inche margin around
                doc.RcgMargin(1440, 1440, 1440, 1440, -1, -1)


            Case ID_INIT_SECT                 ' initialize the section
                doc.RcgInitSect()

            Case ID_SECT_INFO                 ' set the initial page number at 30
                doc.RcgSectInfo(1, 0, True, 30)

            Case ID_BEGIN_HDR                 ' begin the header group
                doc.RcgBeginHdrFtr(Rcn.RCG_HDR)

            Case ID_END_HDR                   ' end the header group
                doc.RcgEndHdrFtr()

            Case ID_BEGIN_FTR                 ' begin the footer group
                doc.RcgBeginHdrFtr(Rcn.RCG_FTR)

            Case ID_END_FTR                   ' end the footer group
                doc.RcgEndHdrFtr()

            Case ID_BEGIN_FRAME               ' begin the footer group
                doc.RcgBeginFrame(True, 2000, 2000, 4000, 4000)

            Case ID_END_FRAME                 ' end the footer group
                doc.RcgEndFrame()

            Case ID_BEGIN_TEXT_BOX            ' begin the text box group
                doc.RcgBeginTextBox(True, 1500, 1500, 2000, 2000, -1, Color.White, Color.Black, 20, False)


            Case ID_END_TEXT_BOX              ' end the text box  group
                doc.RcgEndTextBox()

            Case ID_DRAW_RECT                 ' draw a rectangle
                doc.RcgDrawRect(True, 3500, 3500, 2000, 2000, -1, Color.Magenta, Color.Black, 20, False)


            Case ID_DRAW_LINE                 ' draw a line
                doc.RcgDrawLine(True, 2500, 2500, 3500, 3500, -1, Color.Red, 60)


            Case ID_PAGE_BREAK                 ' page 
                doc.RcgInsertBreak(Rcn.RCG_BREAK_PAGE)

            Case ID_SECT_BREAK                 ' page 
                doc.RcgInsertBreak(Rcn.RCG_BREAK_SECT)

            Case ID_BEGIN_TEXT                ' text begins
                doc.RcgBeginSectText()

            Case ID_RESET_CHAR_PROP           ' reset the character properties
                doc.RcgResetTextProp()

            Case ID_RESET_PARA_PROP           ' reset the paragraph properties
                doc.RcgResetParaProp()

            Case ID_SET_FONT
                SetFont()

            Case ID_CHAR_STYLE_ID             ' specify the character style id
                doc.RcgCharStyleId(1)

            Case ID_PARA_CENTER               ' specify the paragraph centering
                doc.RcgParaFlags(Rcn.RCG_CENTER)

            Case ID_PARA_RIGHT               ' specify the paragraph right justification
                doc.RcgParaFlags(Rcn.RCG_RIGHT)

            Case ID_PARA_DOUBLE_SPACE        ' specify the paragraph double spacing
                doc.RcgParaFlags(Rcn.RCG_DOUBLE_SPACE)

            Case ID_PARA_BORDER              ' Apply single width paragraph border
                doc.RcgParaFlags(Rcn.RCG_PARA_BOX)

            Case ID_PARA_INDENT              ' Apply paragraph indentation
                doc.RcgParaIndent(1440, 1440, 1440)

            Case ID_PARA_SPACE               ' Apply paragraph spacing
                doc.RcgParaSpace(720, 720, 400)

            Case ID_PARA_SHADE               ' Apply paragraph shading
                doc.RcgParaShadeColor(30, Color.Black)

            Case ID_PARA_BULLET               ' Apply paragraph bullet
                doc.RcgParaIndent(720, 720, -720)
                doc.RcgParaBullet(True, Rcn.BLT_ROUND, 0, 1, Nothing, Nothing, 0)


            Case ID_PARA_NUMBERING           ' Apply paragraph Numbering
                doc.RcgParaIndent(720, 720, -720)
                doc.RcgParaBullet(False, Rcn.NBR_DEC, 0, 1, "(", ")", 0)


            Case ID_PARA_TAB_STOP            ' create paragraph tab stops
                doc.RcgParaTabStop(0, 1440, 0)    ' at one inch
                doc.RcgParaTabStop(0, 3 * 1440, 0) ' at 3 inch
                doc.RcgParaTabStop(Rcn.TAB_RIGHT, 5 * 1440, Rcn.TAB_DOT) ' right tab with dot leader at 5 inches


            Case ID_PARA_STYLE_ID             ' specify the paragraph style id
                doc.RcgParaStyleId(1)

            Case ID_INSERT_TEXT
                If (OnOK) Then
                    doc.RcgInsertText(Input1Text.Text)      ' insert the text into the rtf buffer
                    DisableInputArea()
                Else
                    EnableInputArea("Please enter the text here and click OK")
                End If

            Case ID_INSERT_RAW
                If (OnOK) Then
                    str = Input1Text.Text
                    doc.RcgInsertRaw(str)      ' insert the text into the rtf buffer
                    DisableInputArea()
                Else
                    EnableInputArea("Please enter raw RTF code here and click OK")
                End If

            Case ID_INSERT_FNOTE
                If (OnOK) Then
                    str = Input1Text.Text
                    doc.RcgInsertFootnote(Nothing, str)     ' insert the text into the rtf buffer
                    DisableInputArea()
                Else
                    EnableInputArea("Please enter footnote text here and click OK")
                End If

            Case ID_INSERT_TABLE
                InsertTable()


            Case ID_INSERT_PICT
                str = "*.bmp"
                idx = GetFileName(True, str, "bmp", "Bitmap File(*.BMP)|*.BMP|Windows Metafile(*.WMF)|*.WMF|Jpeg File(*.JPG)|*.JPG|Png File(*.PNG)|*.PNG|")
                If (idx > 0) Then doc.RcgInsertPictFile(str, 4000, 4000, False) ' save the code the file


            Case ID_INSERT_LINK_PICT
                str = "*.bmp"
                idx = GetFileName(True, str, "bmp", "Bitmap File(*.BMP)|*.BMP|Windows Metafile(*.WMF)|*.WMF|Jpeg File(*.JPG)|*.JPG|Png File(*.PNG)|*.PNG|")
                If (idx > 0) Then doc.RcgInsertPictFile(str, 0, 0, True) ' save the code the file


            Case ID_INSERT_PAGE_NO
                doc.RcgInsertText("Page# ")      ' page number label
                doc.RcgInsertPageField(True)     ' insert page number field
                doc.RcgInsertText(" Total Pages ")
                doc.RcgInsertPageField(False)    ' insert page count field


            Case ID_INSERT_MERGE_FIELD
                doc.RcgInsertMergeField("FieldName", "FieldData")


            Case ID_OTHER                        ' this code is for miscellaneous testing
                DemoOther()

            Case Else
        End Select

        If (AutoRefresh.Checked) Then ShowRtfCode() ' refresh the code text box

    End Sub
    '******************************************************************************
    '    InsertTable:
    '    Insert a table. This function creates a table of 2 columns and 3 rows.
    '    The first row contains the header.  The table list the name and price of
    '    a couple products.
    '******************************************************************************/
    Sub InsertTable()
        ' Create the header row.
        doc.RcgBeginTableRow(0, 0, Rcn.RCG_CENTER, False, 0)
        doc.RcgNextCellInfo(3 * 1440, 0, 30, Color.White, 20, 40, 20, 40, 0)
        doc.RcgNextCellInfo(1440, 0, 30, Color.White, 40, 20, 20, 40, 0)

        ' row 1 col 1
        doc.RcgBeginCellText()
        doc.RcgResetTextProp()
        doc.RcgTextFont("", 0, Rcn.RCG_BOLD, True)
        doc.RcgInsertText("Products")
        doc.RcgEndCellText()

        ' row 1 col 2
        doc.RcgBeginCellText()
        doc.RcgResetTextProp()
        doc.RcgTextFont("", 0, Rcn.RCG_BOLD, True)
        doc.RcgInsertText("Price")
        doc.RcgEndCellText()

        doc.RcgEndTableRow()

        ' create the second row
        doc.RcgBeginTableRow(0, 0, Rcn.RCG_CENTER, False, 0)
        doc.RcgNextCellInfo(3 * 1440, 0, 0, Color.White, 20, 40, 40, 20, 0)
        doc.RcgNextCellInfo(1440, 0, 0, Color.White, 40, 20, 40, 20, 0)

        ' row 2 col 1
        doc.RcgBeginCellText()
        doc.RcgResetTextProp()
        doc.RcgInsertText("TE Developer's Kit")
        doc.RcgEndCellText()

        ' row 2 col 2
        doc.RcgBeginCellText()
        doc.RcgResetTextProp()
        doc.RcgInsertText("$439.00")
        doc.RcgEndCellText()

        doc.RcgEndTableRow()

        ' create the third row
        doc.RcgBeginTableRow(0, 0, Rcn.RCG_CENTER, False, 0)
        doc.RcgNextCellInfo(3 * 1440, 0, 0, Color.White, 20, 40, 20, 20, 0)
        doc.RcgNextCellInfo(1440, 0, 0, Color.White, 40, 20, 20, 20, 0)

        ' row 2 col 1
        doc.RcgBeginCellText()
        doc.RcgResetTextProp()
        doc.RcgInsertText("ReportEase Plus")
        doc.RcgEndCellText()

        ' row 2 col 2
        doc.RcgBeginCellText()
        doc.RcgResetTextProp()
        doc.RcgInsertText("$459.00")
        doc.RcgEndCellText()

        doc.RcgEndTableRow()

    End Sub
    '******************************************************************************
    '   GetFileName:
    '    This function gets the file name from the user.  The first argument is
    '    true for 'open' dialog box, and false for the 'Save As' dialog box.
    '    The second argument can be used to specify the initial file name and
    '    get the file selection from the user.  The third argument (filter) must
    '    be '|' for delimters for wild card pairs.
    '******************************************************************************/
    Function GetFileName(ByVal open As Boolean, ByRef file As String, ByVal DefExt As String, ByVal filter As String)
        Dim result As Integer
        Dim len As Integer
        Dim LastChar As String

        result = 0

        ' strinp the ending '|' character if any
        len = filter.Length
        LastChar = filter.Substring(len - 1, 1)
        If (LastChar = "|") Then filter = filter.Substring(0, len - 1)

        If (open) Then
            Dim fd As OpenFileDialog
            fd = New OpenFileDialog
            fd.DefaultExt = DefExt
            fd.FileName = file
            fd.Filter = filter
            fd.FilterIndex = 0
            If (filter.Length > 0) Then fd.FilterIndex = 1
            fd.RestoreDirectory = True
            fd.ShowHelp = True
            If (fd.ShowDialog() = DialogResult.OK) Then
                file = fd.FileName
                result = fd.FilterIndex ' base 1
            End If
        Else
            Dim fd As SaveFileDialog
            fd = New SaveFileDialog
            fd.DefaultExt = DefExt
            fd.FileName = file
            fd.Filter = filter
            fd.FilterIndex = 0
            If (filter.Length > 0) Then fd.FilterIndex = 1
            fd.RestoreDirectory = True
            fd.ShowHelp = True

            If (fd.ShowDialog() = DialogResult.OK) Then
                file = fd.FileName
                result = fd.FilterIndex ' base 1
            End If
        End If

        Return result
    End Function

    '******************************************************************************
    '   SetFont:
    '    Show the common dialog to accept new font/color for the text
    '******************************************************************************/
    Sub SetFont()
        Dim fd As FontDialog
        Dim font As Font
        Dim style As Integer
        Dim TwipsSize As Integer
        Dim fs As FontStyle

        fd = New FontDialog
        fs = FontStyle.Regular

        font = New Font("Arial", 12, fs)

        fd.Font = font
        fd.Color = Color.Black
        fd.FontMustExist = True
        fd.ShowColor = True

        If (fd.ShowDialog() = DialogResult.Cancel) Then Exit Sub

        ' Extract the font dialog values
        font = fd.Font

        TwipsSize = (font.SizeInPoints * 20) ' convert PointSize to TwipsSize
        style = 0
        If (font.Bold) Then style = style + Rcn.RCG_BOLD
        If (font.Italic) Then style = style + Rcn.RCG_ITALIC
        If (font.Underline) Then style = style + Rcn.RCG_ULINE
        If (font.Strikeout) Then style = style + Rcn.RCG_STRIKE

        doc.RcgTextFont(font.Name, font.SizeInPoints, style, True)

        doc.RcgTextColor(fd.Color, True)

        font.Dispose()

    End Sub
    '******************************************************************************
    '    ShowRtfCode:
    '    Show the rtf code so far generated.
    '******************************************************************************/
    Sub ShowRtfCode()
        Dim pCode As String
        pCode = doc.RcgGetData()

        Rtf.Text = pCode ' show the generated code
        Rtf.SelectionLength = 0
        Rtf.Refresh()

    End Sub


    '*************************************************************************************
    '  Test code
    '*************************************************************************************
    Sub DemoOther()
        Dim pd As Pdg
        pd = New Pdg

        Dim doc As Rcn
        doc = pd.PdgNewDocObject()

        doc.RcgInitSect()    ' begin first section
        doc.RcgBeginSectText()   ' begin the text for the(section)
        doc.RcgTextFont("Times New Roman", 12, Rcn.RCG_BOLD, True)
        doc.RcgInsertText("This is the first line" + vbCrLf)      ' Ascii 13/10 pair terminates        the(paragraph)
        doc.RcgTextFont("Arial", 12, Rcn.RCG_BOLD, False)
        doc.RcgParaFlags(Rcn.RCG_CENTER)
        doc.RcgInsertText("This is the second paragraph" + vbCrLf)

        pd.PdgGenerateReportFile(doc, "test.pdf")
    End Sub

    Sub SetFunctionName(ByVal id As Integer, ByVal name As String)
        Dim item As ClsBox
        item = New ClsBox(name, id)
        Box.Items.Add(item)
    End Sub

    Friend Class ClsBox
        Friend item As String             ' string
        Friend value As Integer     ' item value

        Sub New(ByVal ArgItem As String, ByVal ArgValue As Integer)
            item = ArgItem
            value = ArgValue
        End Sub
        Public Overrides Function ToString() As String
            ToString = item
        End Function

    End Class

    '******************************************************************************
    '    DisableInputArea:
    '    Disable the input area.
    '*****************************************************************************/
    Sub DisableInputArea()

        'Input1Title.Text = ""
        Input1Text.Text = ""

        ' reset the input box sizes
        Input1Text.Height = InputBoxHeight

        Input1Title.Visible = False
        Input1Text.Visible = False
        OK.Visible = False

    End Sub

    '******************************************************************************
    '   EnableInputArea:
    '    Enable the first input area.
    '******************************************************************************/
    Sub EnableInputArea(ByVal title As String)

        Input1Title.Text = title

        Input1Title.Visible = True
        Input1Text.Visible = True
        OK.Visible = True

        Input1Text.Focus()

    End Sub

    Private Sub GeneratePdf_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GeneratePdf.Click
        Dim result As Boolean
        Dim OutFile As String
        Dim PdfStr As String

        result = False
        OutFile = OutputFile.Text

        If UseBuffer.Checked Then  ' first generate the pdf in a string and then write it to the file
            PdfStr = pdg.PdgGenerateReportString(doc)
            If (PdfStr.Length > 0) Then result = pdg.PdgWriteToFile(OutFile, PdfStr)
        Else
            result = pdg.PdgGenerateReportFile(doc, OutFile)
        End If

        If result Then Status.Text = "Done!" Else Status.Text = "Error!"
        If (result) Then System.Diagnostics.Process.Start(OutFile) ' display pdf
    End Sub
End Class
